﻿using Infragistics.Win;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace WindowsFormsApp11
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.ultraTree1.KeyDown += UltraTree1_KeyDown;

            this.ultraTree1.ViewStyle = Infragistics.Win.UltraWinTree.ViewStyle.OutlookExpress;
            this.ultraTree1.ColumnSettings.TabNavigation = Infragistics.Win.UltraWinTree.TabNavigation.NextControlOnLastCell;
            this.ultraTree1.Override.LabelEdit = DefaultableBoolean.True;
            this.ultraTree1.Override.CellClickAction = Infragistics.Win.UltraWinTree.CellClickAction.EditCell;

            this.ultraTree1.ColumnSettings.TabNavigation = Infragistics.Win.UltraWinTree.TabNavigation.NextControlOnLastCell;
            var columnSet = new Infragistics.Win.UltraWinTree.UltraTreeColumnSet();
            this.ultraTree1.ColumnSettings.RootColumnSet = columnSet;
            columnSet.Columns.Add("String 1");
            columnSet.Columns.Add("Boolean 1");

            foreach (var column in columnSet.Columns)
            {
                switch (column.Key)
                {
                    case "Boolean 1":
                        column.DataType = typeof(bool);
                        var checkEditor = new CheckEditor();
                        column.Editor = checkEditor;
                        column.AllowCellEdit = Infragistics.Win.UltraWinTree.AllowCellEdit.Full;
                        break;
                    default:
                        column.AllowCellEdit = Infragistics.Win.UltraWinTree.AllowCellEdit.ReadOnly;
                        break;
                }
            }

            for (int i = 0; i < 10; i++)
            {
                var node = this.ultraTree1.Nodes.Add();
                node.Cells["String 1"].Value = DummyDataCreator.RandomString();
                node.Cells["Boolean 1"].Value = DummyDataCreator.RandomBool();
            }
        }

        private void UltraTree1_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Space)
            {
                var activeNode = this.ultraTree1.ActiveNode;
                if (null == activeNode)
                    return;

                // If the active cell is alraedy the checkbox cell, then we can simply bail out, since
                // toggling the checkbox will work automatically. 
                var activeCell = this.ultraTree1.ActiveCell;
                if (activeCell.Key == "Boolean 1")
                    return;

                var originalValue = (bool)activeNode.Cells["Boolean 1"].Value;
                activeNode.Cells["Boolean 1"].Value = !originalValue;
                e.Handled = true;
                e.SuppressKeyPress = true;
            }
        }
    }
}

